/*
Notice of Copyright Ownership

Copyright (c) 2003-2010 Jensen Data Systems. Inc.

This code was produced by and is copyrighted by Jensen Data Systems, Inc. All data 
mentioned or referred to, including names, addresses, phone numbers, descriptions, 
and images, are fictitious. Any resemblance to actual persons, companies, and products 
is purely coincidental.

This code is intended to be used in conjunction with database examples and 
descriptions found in the book: 
1. Advantage Database Server: A Developer's Guide, 2nd Edition 
by Cary Jensen, Ph.D. and Loy Anderson, Ph.D. (2010, Jensen Data Systems, Inc.)

For information on purchasing this book, visit:
http://www.JensenDataSystems.com/ADSBook10
*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Advantage.Data.Provider;
using System.Data.Common;
using System.Data.OleDb;

namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
    public class Form1 : System.Windows.Forms.Form
    {
        private System.Windows.Forms.DataGrid dataGrid1;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;
        public AdsConnection connection;
        public IDbCommand command;
        public AdsCommand paramCommand;
        public IDataReader dataReader;
        private System.Windows.Forms.Panel panel1;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Panel panel2;
        private System.Windows.Forms.TextBox paramText;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.ListBox productList;
        private System.Windows.Forms.Panel panel3;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.TextBox oldAddressText;
        private System.Windows.Forms.TextBox newAddressText;
        private System.Windows.Forms.TextBox selectText;
        private System.Windows.Forms.Panel panel4;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Panel panel5;
        private System.Windows.Forms.TextBox custNoText;
        private System.Windows.Forms.TextBox tableNameText;
        private System.Windows.Forms.Label label7;
        private System.Windows.Forms.Label label8;
        private System.Windows.Forms.Label label9;
        private System.Windows.Forms.TextBox oldPassText;
        private System.Windows.Forms.TextBox newPassText;
        private System.Windows.Forms.TextBox confirmPassText;
        private System.Windows.Forms.Button executeSELECTBtn;
        private System.Windows.Forms.Button listProductsBtn;
        private System.Windows.Forms.Button clearListBtn;
        private System.Windows.Forms.Button doParamQuery;
        private System.Windows.Forms.Button callStoredProcBtn;
        private System.Windows.Forms.Button getAddressBtn;
        private System.Windows.Forms.Button setAddressBtn;
        private System.Windows.Forms.Button addTableBtn;
        private System.Windows.Forms.Button changePasswordBtn;

         private const String DataPath = "\\\\server\\share\\" +
          "adsbook\\DemoDictionary.add;";

        //private const String DataPath = "c:\\adsbook\\DemoDictionary.add;";


        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();



            //initialize our data components
            InitializeDataComponents();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.dataGrid1 = new System.Windows.Forms.DataGrid();
            this.panel1 = new System.Windows.Forms.Panel();
            this.selectText = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.executeSELECTBtn = new System.Windows.Forms.Button();
            this.panel2 = new System.Windows.Forms.Panel();
            this.callStoredProcBtn = new System.Windows.Forms.Button();
            this.clearListBtn = new System.Windows.Forms.Button();
            this.doParamQuery = new System.Windows.Forms.Button();
            this.paramText = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.productList = new System.Windows.Forms.ListBox();
            this.listProductsBtn = new System.Windows.Forms.Button();
            this.panel3 = new System.Windows.Forms.Panel();
            this.custNoText = new System.Windows.Forms.TextBox();
            this.newAddressText = new System.Windows.Forms.TextBox();
            this.oldAddressText = new System.Windows.Forms.TextBox();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.setAddressBtn = new System.Windows.Forms.Button();
            this.getAddressBtn = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.panel4 = new System.Windows.Forms.Panel();
            this.addTableBtn = new System.Windows.Forms.Button();
            this.tableNameText = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.panel5 = new System.Windows.Forms.Panel();
            this.confirmPassText = new System.Windows.Forms.TextBox();
            this.newPassText = new System.Windows.Forms.TextBox();
            this.oldPassText = new System.Windows.Forms.TextBox();
            this.label9 = new System.Windows.Forms.Label();
            this.label8 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.changePasswordBtn = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
            this.panel1.SuspendLayout();
            this.panel2.SuspendLayout();
            this.panel3.SuspendLayout();
            this.panel4.SuspendLayout();
            this.panel5.SuspendLayout();
            this.SuspendLayout();
            // 
            // dataGrid1
            // 
            this.dataGrid1.DataMember = "";
            this.dataGrid1.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.dataGrid1.Location = new System.Drawing.Point(0, 349);
            this.dataGrid1.Name = "dataGrid1";
            this.dataGrid1.Size = new System.Drawing.Size(688, 120);
            this.dataGrid1.TabIndex = 2;
            // 
            // panel1
            // 
            this.panel1.AllowDrop = true;
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Controls.Add(this.selectText);
            this.panel1.Controls.Add(this.label1);
            this.panel1.Controls.Add(this.executeSELECTBtn);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(688, 64);
            this.panel1.TabIndex = 23;
            // 
            // selectText
            // 
            this.selectText.Location = new System.Drawing.Point(40, 38);
            this.selectText.Name = "selectText";
            this.selectText.Size = new System.Drawing.Size(424, 20);
            this.selectText.TabIndex = 6;
            this.selectText.Text = "SELECT * FROM Customer";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(32, 6);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(100, 23);
            this.label1.TabIndex = 5;
            this.label1.Text = "SQL SELECT";
            // 
            // executeSELECTBtn
            // 
            this.executeSELECTBtn.Location = new System.Drawing.Point(152, 6);
            this.executeSELECTBtn.Name = "executeSELECTBtn";
            this.executeSELECTBtn.Size = new System.Drawing.Size(160, 24);
            this.executeSELECTBtn.TabIndex = 4;
            this.executeSELECTBtn.Text = "Execute SELECT";
            this.executeSELECTBtn.Click += new System.EventHandler(this.executeSELECTBtn_Click);
            // 
            // panel2
            // 
            this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel2.Controls.Add(this.callStoredProcBtn);
            this.panel2.Controls.Add(this.clearListBtn);
            this.panel2.Controls.Add(this.doParamQuery);
            this.panel2.Controls.Add(this.paramText);
            this.panel2.Controls.Add(this.label2);
            this.panel2.Controls.Add(this.productList);
            this.panel2.Controls.Add(this.listProductsBtn);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel2.Location = new System.Drawing.Point(0, 64);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(688, 88);
            this.panel2.TabIndex = 24;
            // 
            // callStoredProcBtn
            // 
            this.callStoredProcBtn.Location = new System.Drawing.Point(544, 48);
            this.callStoredProcBtn.Name = "callStoredProcBtn";
            this.callStoredProcBtn.Size = new System.Drawing.Size(136, 24);
            this.callStoredProcBtn.TabIndex = 23;
            this.callStoredProcBtn.Text = "Show 10% of Invoices";
            this.callStoredProcBtn.Click += new System.EventHandler(this.callStoredProc_Click_1);
            // 
            // clearListBtn
            // 
            this.clearListBtn.Location = new System.Drawing.Point(12, 46);
            this.clearListBtn.Name = "clearListBtn";
            this.clearListBtn.Size = new System.Drawing.Size(120, 24);
            this.clearListBtn.TabIndex = 22;
            this.clearListBtn.Text = "Clear List";
            this.clearListBtn.Click += new System.EventHandler(this.clearListBtn_Click);
            // 
            // doParamQuery
            // 
            this.doParamQuery.Location = new System.Drawing.Point(544, 10);
            this.doParamQuery.Name = "doParamQuery";
            this.doParamQuery.Size = new System.Drawing.Size(136, 23);
            this.doParamQuery.TabIndex = 21;
            this.doParamQuery.Text = "Show Invoices";
            this.doParamQuery.Click += new System.EventHandler(this.doParamQuery_Click);
            // 
            // paramText
            // 
            this.paramText.Location = new System.Drawing.Point(363, 35);
            this.paramText.Name = "paramText";
            this.paramText.Size = new System.Drawing.Size(100, 20);
            this.paramText.TabIndex = 20;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(360, 16);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(192, 16);
            this.label2.TabIndex = 19;
            this.label2.Text = "Show Invoices for Customer Number";
            // 
            // productList
            // 
            this.productList.Location = new System.Drawing.Point(144, 16);
            this.productList.Name = "productList";
            this.productList.Size = new System.Drawing.Size(208, 69);
            this.productList.TabIndex = 18;
            // 
            // listProductsBtn
            // 
            this.listProductsBtn.Location = new System.Drawing.Point(12, 14);
            this.listProductsBtn.Name = "listProductsBtn";
            this.listProductsBtn.Size = new System.Drawing.Size(120, 24);
            this.listProductsBtn.TabIndex = 17;
            this.listProductsBtn.Text = "List Products";
            this.listProductsBtn.Click += new System.EventHandler(this.listProductsBtn_Click);
            // 
            // panel3
            // 
            this.panel3.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel3.Controls.Add(this.custNoText);
            this.panel3.Controls.Add(this.newAddressText);
            this.panel3.Controls.Add(this.oldAddressText);
            this.panel3.Controls.Add(this.label5);
            this.panel3.Controls.Add(this.label4);
            this.panel3.Controls.Add(this.setAddressBtn);
            this.panel3.Controls.Add(this.getAddressBtn);
            this.panel3.Controls.Add(this.label3);
            this.panel3.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel3.Location = new System.Drawing.Point(0, 152);
            this.panel3.Name = "panel3";
            this.panel3.Size = new System.Drawing.Size(688, 80);
            this.panel3.TabIndex = 25;
            // 
            // custNoText
            // 
            this.custNoText.Location = new System.Drawing.Point(5, 27);
            this.custNoText.Name = "custNoText";
            this.custNoText.Size = new System.Drawing.Size(120, 20);
            this.custNoText.TabIndex = 25;
            // 
            // newAddressText
            // 
            this.newAddressText.Location = new System.Drawing.Point(350, 40);
            this.newAddressText.Name = "newAddressText";
            this.newAddressText.Size = new System.Drawing.Size(256, 20);
            this.newAddressText.TabIndex = 24;
            // 
            // oldAddressText
            // 
            this.oldAddressText.Location = new System.Drawing.Point(350, 8);
            this.oldAddressText.Name = "oldAddressText";
            this.oldAddressText.Size = new System.Drawing.Size(256, 20);
            this.oldAddressText.TabIndex = 23;
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(270, 42);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(100, 24);
            this.label5.TabIndex = 22;
            this.label5.Text = "New Address";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(270, 10);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(100, 24);
            this.label4.TabIndex = 21;
            this.label4.Text = "Old Address";
            // 
            // setAddressBtn
            // 
            this.setAddressBtn.Location = new System.Drawing.Point(142, 50);
            this.setAddressBtn.Name = "setAddressBtn";
            this.setAddressBtn.Size = new System.Drawing.Size(104, 25);
            this.setAddressBtn.TabIndex = 20;
            this.setAddressBtn.Text = "Set Address";
            this.setAddressBtn.Click += new System.EventHandler(this.setAddressBtn_Click);
            // 
            // getAddressBtn
            // 
            this.getAddressBtn.Location = new System.Drawing.Point(8, 51);
            this.getAddressBtn.Name = "getAddressBtn";
            this.getAddressBtn.Size = new System.Drawing.Size(112, 23);
            this.getAddressBtn.TabIndex = 19;
            this.getAddressBtn.Text = "Get Address";
            this.getAddressBtn.Click += new System.EventHandler(this.getAddressBtn_Click);
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 8);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(100, 14);
            this.label3.TabIndex = 18;
            this.label3.Text = "Customer Number";
            // 
            // panel4
            // 
            this.panel4.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel4.Controls.Add(this.addTableBtn);
            this.panel4.Controls.Add(this.tableNameText);
            this.panel4.Controls.Add(this.label6);
            this.panel4.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel4.Location = new System.Drawing.Point(0, 232);
            this.panel4.Name = "panel4";
            this.panel4.Size = new System.Drawing.Size(688, 56);
            this.panel4.TabIndex = 26;
            // 
            // addTableBtn
            // 
            this.addTableBtn.Location = new System.Drawing.Point(200, 8);
            this.addTableBtn.Name = "addTableBtn";
            this.addTableBtn.Size = new System.Drawing.Size(192, 31);
            this.addTableBtn.TabIndex = 2;
            this.addTableBtn.Text = "Create Table and Grant Rights";
            this.addTableBtn.Click += new System.EventHandler(this.addTableBtn_Click);
            // 
            // tableNameText
            // 
            this.tableNameText.Location = new System.Drawing.Point(14, 26);
            this.tableNameText.Name = "tableNameText";
            this.tableNameText.Size = new System.Drawing.Size(152, 20);
            this.tableNameText.TabIndex = 1;
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(8, 8);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(184, 16);
            this.label6.TabIndex = 0;
            this.label6.Text = "Table Name to Add (ex: DEMO7)";
            // 
            // panel5
            // 
            this.panel5.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel5.Controls.Add(this.confirmPassText);
            this.panel5.Controls.Add(this.newPassText);
            this.panel5.Controls.Add(this.oldPassText);
            this.panel5.Controls.Add(this.label9);
            this.panel5.Controls.Add(this.label8);
            this.panel5.Controls.Add(this.label7);
            this.panel5.Controls.Add(this.changePasswordBtn);
            this.panel5.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel5.Location = new System.Drawing.Point(0, 288);
            this.panel5.Name = "panel5";
            this.panel5.Size = new System.Drawing.Size(688, 64);
            this.panel5.TabIndex = 27;
            // 
            // confirmPassText
            // 
            this.confirmPassText.Location = new System.Drawing.Point(264, 32);
            this.confirmPassText.Name = "confirmPassText";
            this.confirmPassText.Size = new System.Drawing.Size(100, 20);
            this.confirmPassText.TabIndex = 6;
            // 
            // newPassText
            // 
            this.newPassText.Location = new System.Drawing.Point(136, 32);
            this.newPassText.Name = "newPassText";
            this.newPassText.Size = new System.Drawing.Size(100, 20);
            this.newPassText.TabIndex = 5;
            // 
            // oldPassText
            // 
            this.oldPassText.Location = new System.Drawing.Point(8, 32);
            this.oldPassText.Name = "oldPassText";
            this.oldPassText.Size = new System.Drawing.Size(100, 20);
            this.oldPassText.TabIndex = 4;
            // 
            // label9
            // 
            this.label9.Location = new System.Drawing.Point(262, 10);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(144, 16);
            this.label9.TabIndex = 3;
            this.label9.Text = "Confirm New Password";
            // 
            // label8
            // 
            this.label8.Location = new System.Drawing.Point(136, 11);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(100, 16);
            this.label8.TabIndex = 2;
            this.label8.Text = "New Password";
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(8, 8);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(100, 16);
            this.label7.TabIndex = 1;
            this.label7.Text = "Current Password";
            // 
            // changePasswordBtn
            // 
            this.changePasswordBtn.Location = new System.Drawing.Point(416, 30);
            this.changePasswordBtn.Name = "changePasswordBtn";
            this.changePasswordBtn.Size = new System.Drawing.Size(152, 23);
            this.changePasswordBtn.TabIndex = 0;
            this.changePasswordBtn.Text = "Change Password";
            this.changePasswordBtn.Click += new System.EventHandler(this.changePasswordBtn_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(688, 469);
            this.Controls.Add(this.panel5);
            this.Controls.Add(this.panel4);
            this.Controls.Add(this.panel3);
            this.Controls.Add(this.panel2);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.dataGrid1);
            this.Name = "Form1";
            this.Text = "ADS and ADO.NET";
            ((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
            this.panel1.ResumeLayout(false);
            this.panel1.PerformLayout();
            this.panel2.ResumeLayout(false);
            this.panel2.PerformLayout();
            this.panel3.ResumeLayout(false);
            this.panel3.PerformLayout();
            this.panel4.ResumeLayout(false);
            this.panel4.PerformLayout();
            this.panel5.ResumeLayout(false);
            this.panel5.PerformLayout();
            this.ResumeLayout(false);

        }
        #endregion

        private void InitializeDataComponents()
        {
            connection = new AdsConnection();
            connection.ConnectionString = "Data Source=" + DataPath +
              ";user ID=adsuser;password=password;" +
              "ServerType= LOCAL | REMOTE;TrimTrailingSpaces=True";
            connection.Open();
            command = new AdsCommand();
            command = connection.CreateCommand();
            paramCommand = new AdsCommand("SELECT * FROM INVOICE " +
              "WHERE [Customer ID] = ?", connection);
            paramCommand.Parameters.Add(1, System.Data.DbType.Int32);
        }

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }

        private void executeSELECTBtn_Click(object sender, System.EventArgs e)
        {
            IDataAdapter adapter;
            adapter = new AdsDataAdapter(selectText.Text, connection);
            DataSet ds = new DataSet();
            adapter.Fill(ds);
            DataTable dt = ds.Tables[0];
            dataGrid1.DataSource = dt;
        }

        private void listProductsBtn_Click(object sender,
          System.EventArgs e)
        {
            command.CommandText = "SELECT * FROM PRODUCTS";
            dataReader = command.ExecuteReader();
            while (dataReader.Read())
            {
                productList.Items.Add(dataReader.GetString(0) + "  " +
                  dataReader.GetString(1));
            }
            dataReader.Close();
        }

        private void clearListBtn_Click(object sender, System.EventArgs e)
        {
            productList.Items.Clear();
        }

        private void doParamQuery_Click(object sender,
          System.EventArgs e)
        {
            IDataAdapter dataAdapter;
            DataSet ds = new DataSet();
            DataTable dt;
            if (paramText.Text.Equals(""))
            {
                MessageBox.Show(this, "You must supply a customer ID");
                return;
            }
            paramCommand.Parameters[0].Value = Int32.Parse(paramText.Text);
            dataAdapter = new AdsDataAdapter(paramCommand);
            dataAdapter.Fill(ds);
            dt = ds.Tables[0];
            if (dt.Rows.Count == 0)
            {
                MessageBox.Show(this, "No invoices for customer ID");
                return;
            }
            dataGrid1.DataSource = dt;
        }

        private void getAddressBtn_Click(object sender,
          System.EventArgs e)
        {
            AdsCommand getCustCommand;
            AdsDataReader dataReader;
            String custNo;

            custNo = custNoText.Text;

            if (custNo.Equals(""))
            {
                MessageBox.Show(this, "You must supply a customer ID");
                return;
            }

            getCustCommand = new AdsCommand(
              "SELECT * FROM CUSTOMER WHERE [Customer ID] = ?",
              connection);
            getCustCommand.Parameters.Add(1, System.Data.DbType.Int32);
            getCustCommand.Parameters[0].Value =
              Int32.Parse(custNo);

            dataReader = getCustCommand.ExecuteReader();
            if (dataReader.Read())
            {
                oldAddressText.Text =
                  dataReader.GetString
                    (dataReader.GetOrdinal("Address"));
            }
            else
            {
                MessageBox.Show(this, "Customer " + custNo +
                  " not found");
            }
            dataReader.Close();
        }

        private void setAddressBtn_Click(object sender,
          System.EventArgs e)
        {
            AdsCommand getCustCommand;
            AdsExtendedReader extendedReader;
            String custNo;

            custNo = custNoText.Text;

            if (custNo.Equals(""))
            {
                MessageBox.Show(this, "You must supply a customer ID");
                return;
            }

            getCustCommand = new AdsCommand(
              "SELECT * FROM CUSTOMER WHERE [Customer ID] = ?",
              connection);
            getCustCommand.Parameters.Add(1, System.Data.DbType.Int32);
            getCustCommand.Parameters[0].Value =
              Int32.Parse(custNo);

            extendedReader = getCustCommand.ExecuteExtendedReader();
            if (extendedReader.Read())
            {
                extendedReader.SetString(
                  extendedReader.GetOrdinal("Address"),
                  newAddressText.Text);
                extendedReader.WriteRecord();
            }
            else
            {
                MessageBox.Show(this, "Customer " + custNo +
                  " not found");
            }
            extendedReader.Close();
        }

        private void addTableBtn_Click(object sender,
          System.EventArgs e)
        {
            AdsConnection adminConnection;
            IDbCommand adminCommand;
            AdsDataAdapter adminAdapter;
            DataSet ds;
            DataTable dt;
            DataRow dr;
            String tabName;

            tabName = tableNameText.Text;
            if (tabName.Equals(""))
            {
                MessageBox.Show(this,
                  "Please enter the name of the table to create");
                return;
            }
            //Check for SQL injections hack
            if ((tabName.IndexOf(";") >= 0))
            {
                MessageBox.Show(this,
                  "Table name may not contain a semicolon");
                return;
            }
            try
            {
                adminConnection = new AdsConnection(
                  "Data Source=" + DataPath + ";user ID=adssys;" +
                  //Add password if ADSSYS uses a password
                  //"password=password;" +
                  "ServerType=ADS_LOCAL_SERVER | ADS_REMOTE_SERVER;" +
                  "TrimTrailingSpaces=True");
                adminConnection.Open();
                adminAdapter = new AdsDataAdapter("SELECT Name FROM " +
                  "system.tables " +
                  "WHERE UCase(Name) = '" + tabName.ToUpper() + "'",
                  adminConnection);
                ds = new DataSet();
                adminAdapter.Fill(ds);
                dt = ds.Tables[0];
                if (dt.Rows.Count != 0)
                {
                    MessageBox.Show(this,
                      "This table already exists. Cannot create");
                    return;
                }
                adminCommand = new AdsCommand("CREATE TABLE [" +
                  tabName + "] " +
                  "([Full Name] CHAR(30), [Date of Birth] DATE," +
                  "[Credit Limit] MONEY, Active LOGICAL)",
                   adminConnection);
                adminCommand.ExecuteNonQuery();
                adminAdapter = new AdsDataAdapter("SELECT Name FROM " +
                  "system.usergroups WHERE NAME NOT LIKE 'DB:%'", 
                  adminConnection);
                ds = new DataSet();
                adminAdapter.Fill(ds);
                dt = ds.Tables[0];
                if (dt.Rows.Count == 0)
                {
                    MessageBox.Show(this, "No groups to grant rights to");
                    return;
                }
                adminCommand = adminConnection.CreateCommand();
                for (int i = 0; i <= dt.Rows.Count - 1; i++)
                {
                    dr = dt.Rows[i];
                    adminCommand.CommandText = "GRANT ALL ON " +
                      tabName + " TO \"" + dr[0].ToString() + "\"";
                    adminCommand.ExecuteNonQuery();
                }
            }
            catch (System.Exception ex)
            {
                Console.WriteLine("Exception", ex);
                throw (ex);
            }
            MessageBox.Show(this,
              "The " + tabName + " table has been " +
              "created, with rights granted to all groups");
            return;
        }

        private Boolean CheckPassword(String uName, String pass)
        {
            //Verify the current password
            AdsConnection tempConnection;
            tempConnection = new AdsConnection(
             "Data Source=" + DataPath + ";user ID=" + uName + ";" +
             "password=" + pass + ";" +
             "ServerType=ADS_LOCAL_SERVER | ADS_REMOTE_SERVER;" +
             "TrimTrailingSpaces=True");
            try
            {
                tempConnection.Open();
                tempConnection.Close();
                return true;
            }
            catch (Exception)
            {
                return false;
            }
        } //CheckPassword

        private void changePasswordBtn_Click(object sender,
          System.EventArgs e)
        {
            IDataReader dataReader;
            String userName;
            String oldPass, newPass, confirmPass;
            oldPass = oldPassText.Text;
            if (oldPass.Equals(""))
            {
                MessageBox.Show(this,
                 "Please enter your current password");
                return;
            }
            newPass = newPassText.Text;
            if (newPass.Equals(""))
            {
                MessageBox.Show(this,
                 "Please enter your new password");
                return;
            }
            confirmPass = confirmPassText.Text;
            if (confirmPass.Equals(""))
            {
                MessageBox.Show(this,
                 "Please confirm your new password");
                return;
            }
            if (!newPass.Equals(confirmPass))
            {
                MessageBox.Show(this,
                 "New passwords do not match");
                return;
            }
            if ((newPass.IndexOf(";") >= 0))
            {
                MessageBox.Show(this,
                 "Password may not contain a semicolon");
                return;
            }
            //Get user name
            command = connection.CreateCommand();
            command.CommandText = "SELECT USER() FROM system.iota";
            dataReader = command.ExecuteReader();
            dataReader.Read();
            userName = dataReader.GetString(0);
            dataReader.Close();
            //Verify current password
            if (!CheckPassword(userName, oldPass))
            {
                MessageBox.Show("Cannot validate your current password. "
                  + "Cannot change password");
                return;
            }

            try
            {
                command.CommandText = "EXECUTE PROCEDURE " +
                  "sp_ModifyUserProperty('" +
                  userName + "', 'USER_PASSWORD', '" + newPass + "')";
                command.ExecuteNonQuery();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return;
            }
            MessageBox.Show("Password successfully changed. " +
              "New password will be valid next time you connect");
        }

        private void callStoredProc_Click_1(object sender,
          System.EventArgs e)
        {
            AdsCommand storedProcCommand;
            IDataAdapter dataAdapter;
            DataSet ds = new DataSet();
            DataTable dt;
            if (paramText.Text.Equals(""))
            {
                MessageBox.Show(this, "You must supply a customer ID");
                return;
            }
            storedProcCommand = new AdsCommand("Get10PercentSQL",
              connection);
            storedProcCommand.CommandType =
              CommandType.StoredProcedure;
            storedProcCommand.Parameters.Add(1,
              System.Data.DbType.Int32);
            storedProcCommand.Parameters[0].Value =
              Int32.Parse(paramText.Text);
            dataAdapter = new AdsDataAdapter(storedProcCommand);
            dataAdapter.Fill(ds);
            dt = ds.Tables[0];
            if (dt.Rows.Count == 0)
            {
                MessageBox.Show(this, "No invoices for customer ID");
                return;
            }
            dataGrid1.DataSource = dt;
        }
    }
}
