/*
Notice of Copyright Ownership

Copyright (c) 2003-2010 Jensen Data Systems. Inc.

This code was produced by and is copyrighted by Jensen Data Systems, Inc. All data 
mentioned or referred to, including names, addresses, phone numbers, descriptions, 
and images, are fictitious. Any resemblance to actual persons, companies, and products 
is purely coincidental.

This code is intended to be used in conjunction with database examples and 
descriptions found in the book: 
1. Advantage Database Server: A Developer's Guide, 2nd Edition 
by Cary Jensen, Ph.D. and Loy Anderson, Ph.D. (2010, Jensen Data Systems, Inc.)

For information on purchasing this book, visit:
http://www.JensenDataSystems.com/ADSBook10
*/

using System;
using System.Data;
using Advantage.Data.Provider;

namespace TriggerDemoCS
{
  /// <summary>
  /// Summary description for trig_functions.
  /// </summary>
  public class trig_functions
  {
    public trig_functions()
    {
    }

    public Int32 GenGuidID(Int32 ulConnectionID,
                           Int32 hConnection,
                           String strTriggerName,
                           String strTableName,
                           Int32 ulEventType,
                           Int32 ulTriggerType,
                           Int32 ulRecNo)
    {
      AdsConnection oConn =
        new AdsConnection("ConnectionHandle=" +
        hConnection.ToString());
      AdsCommand oCommand;
      AdsCommand oCommandNew;
      AdsExtendedReader oExtReader;
      AdsDataReader oDataReader;
      Guid myGuid = Guid.NewGuid();
      String s = myGuid.ToString();
      try
      {
        oConn.Open();
        oCommand = oConn.CreateCommand();
        oCommandNew = oConn.CreateCommand();

        oCommand.CommandText = "SELECT * FROM __new";
        oDataReader = oCommand.ExecuteReader();
        //Get a cursor to the trigger table
        oCommandNew.CommandText = "SELECT * FROM " +
          "[" + strTableName + "]";
        oExtReader = oCommandNew.ExecuteExtendedReader();

        //insert new, blank record
        oExtReader.AppendRecord();
        oDataReader.Read();
        if (oDataReader.IsDBNull(0))
        { oExtReader.SetString(0, s); }
        else
        { oExtReader.SetString(0, oDataReader.GetString(0)); }

        for (Int16 i = 1;
           i < oDataReader.FieldCount - 1; ++i)
        {
          if (!oDataReader.IsDBNull(i))
          {
            oExtReader.SetValue(i, oDataReader.GetValue(i));
          }
        }

        oExtReader.WriteRecord();
        oExtReader.Close();
        oDataReader.Close();
      }
      catch (Exception e)
      {
        AdsCommand oErrCommand = oConn.CreateCommand();
        oErrCommand.CommandText = "INSERT INTO __error " +
          "VALUES( 0, '" + e.Message + "' )";
        oErrCommand.ExecuteNonQuery();
      }

      // Result is currently reserved and not used. 
      //Always return zero.
      return 0;

    }  // GenGuidID

    // Do not change or remove this function. It is used internally by the Advantage server
    public Int32 GetInterfaceVersion()
    {
      return 3;
    }   // GetInterfaceVersion

  }   // trig_functions

}   // TriggerDemoCS
